/*****************************************************************************
 *****************************************************************************
 Copyright (c) 2000-2001, AEP Ltd. 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.

 3. Neither the name of AEP Ltd. nor the names of its contributors 
 may be used to endorse or promote products derived from this software 
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
****************************************************************************/

/**********************************************************************
*                                                                     *
* AEP Ltd.                                                            *
*                                                                     *
* This software is supplied under the terms of the license included   *
* above.  All use of this software must be in accordance with the     *
* terms of that license.                                              *
*                                                                     *
**********************************************************************/


#include "aep_i_types.h"

/*Convert n longs from Big Endian format to little endian format*/
void BEndToLEnd(AEP_U8 *buf, unsigned longs)
{
    #ifdef B_ENDIAN
                do {
                *(AEP_U32 *) buf = (AEP_U32) ((unsigned) buf[1] << 8 | buf[0]) |
                        ((unsigned) buf[3] << 8 | buf[2])  << 16;

                buf += 4;
                } while (--longs);
        
        #endif
}

/*Convert n longs from Big Endian format to little endian format*/
void BEndToLEndCopy(AEP_U8 *destbuf, AEP_U8 *srcbuf, unsigned longs)
{

        #ifdef B_ENDIAN
        
                do {
                *(AEP_U32 *) destbuf = (AEP_U32) ((unsigned) srcbuf[1] << 8 | srcbuf[0]) |
                        ((unsigned) srcbuf[3] << 8 | srcbuf[2])  << 16;
                
                destbuf += 4;
                srcbuf += 4;
                } while (--longs);
        
        #elif L_ENDIAN

                memcpy (destbuf, srcbuf, longs * sizeof(AEP_U32));
        
        #endif

}

/*Convert n longs from Little Endian format to Big endian format*/
void LEndToBEnd(AEP_U8 *buf, unsigned longs)
{

        #ifdef B_ENDIAN
                do {
                *(AEP_U32 *) buf = (AEP_U32) ((unsigned) buf[3] << 8 | buf[2]) << 16 |
                        ((unsigned) buf[1] << 8 | buf[0]);

                buf += 4;
                } while (--longs);
        #endif

}
